/*
 *
 *  vjgen.h is part of Linux VeeJay 
 *    
 *	Copyright (C) 2002 N. Elburg - elburg@hio.hen.nl 
 *	
 *  vj-gen is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  vjgen is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 *
 *  This file adds dynamic link loading to veejay; 
 *  
 *
 */
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <dirent.h>
#include <dlfcn.h>
#include <string.h>
#include <time.h>


typedef struct _vjgen_modules {
    char *name;
    int (*vjgen_make) (void);
} module;

typedef module *vjgenRegisterFunc(void);

/* the plugins */

extern vjgenRegisterFunc hmsRegister;
extern vjgenRegisterFunc cubicsRegister;
extern vjgenRegisterFunc noiserRegister;
extern vjgenRegisterFunc psychoIRegister;
extern vjgenRegisterFunc psychoIIRegister;
extern vjgenRegisterFunc psychoIIIRegister;
extern vjgenRegisterFunc psychoIVRegister;
extern vjgenRegisterFunc dicesRegister;
extern vjgenRegisterFunc transistRegister;

/********************************************/

int vjgen_register(char *dirname);

int vjgen_new_samplelist(int samples, int duration, int speed);
/* limit: limits nr of samples */
int vjgen_make_samplelist(int mode, int samples, int duration, int speed);

char *vjgen_get_module_name(int mode);
int vjgen_loaded_modules();
void vjgen_append_samrand(int start_sample, int max_loops);
void vjgen_print_list();
